// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.32.0
// 	protoc        v3.21.12
// source: sp_sdk.proto

package protos

import (
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

type ExecStatus int32

const (
	// Unset status. This should never be returned by the SDK. If it does, it is
	// probably a bug (and you should file an issue)
	ExecStatus_EXEC_STATUS_UNSET ExecStatus = 0
	// Indicates that the step execution evaluated to "true"
	ExecStatus_EXEC_STATUS_TRUE ExecStatus = 1
	// Indicates that the step execution evaluated to "false"
	ExecStatus_EXEC_STATUS_FALSE ExecStatus = 2
	// Indicates that the SDK encountered an error while trying to process the
	// request. Example error cases: SDK can't find the appropriate Wasm module,
	// Wasm function cannot alloc or dealloc memory, etc.
	ExecStatus_EXEC_STATUS_ERROR ExecStatus = 3
	// Indicates that the SDK was configured to operate in async mode.
	// Step execution will occur asynchronously in a background worker-group.
	ExecStatus_EXEC_STATUS_ASYNC ExecStatus = 4
	// Indicates that the SDK was configured to operate in sampling mode.
	// Step execution was skipped for this request due to configured sampling rate.
	//
	// If this status is set, you can safely ignore the rest of the response as
	// the execution for this request was skipped due to being sampled out.
	//
	// Non-sampled messages will have TRUE/FALSE/ERROR status set as any other
	// non-sampled message.
	ExecStatus_EXEC_STATUS_SAMPLING ExecStatus = 5
)

// Enum value maps for ExecStatus.
var (
	ExecStatus_name = map[int32]string{
		0: "EXEC_STATUS_UNSET",
		1: "EXEC_STATUS_TRUE",
		2: "EXEC_STATUS_FALSE",
		3: "EXEC_STATUS_ERROR",
		4: "EXEC_STATUS_ASYNC",
		5: "EXEC_STATUS_SAMPLING",
	}
	ExecStatus_value = map[string]int32{
		"EXEC_STATUS_UNSET":    0,
		"EXEC_STATUS_TRUE":     1,
		"EXEC_STATUS_FALSE":    2,
		"EXEC_STATUS_ERROR":    3,
		"EXEC_STATUS_ASYNC":    4,
		"EXEC_STATUS_SAMPLING": 5,
	}
)

func (x ExecStatus) Enum() *ExecStatus {
	p := new(ExecStatus)
	*p = x
	return p
}

func (x ExecStatus) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (ExecStatus) Descriptor() protoreflect.EnumDescriptor {
	return file_sp_sdk_proto_enumTypes[0].Descriptor()
}

func (ExecStatus) Type() protoreflect.EnumType {
	return &file_sp_sdk_proto_enumTypes[0]
}

func (x ExecStatus) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use ExecStatus.Descriptor instead.
func (ExecStatus) EnumDescriptor() ([]byte, []int) {
	return file_sp_sdk_proto_rawDescGZIP(), []int{0}
}

type SDKMode int32

const (
	SDKMode_SDK_MODE_UNSET SDKMode = 0
	// Process() will handle the message inline.
	// This method should be used when you need to modify the input data and pass
	// the modified data back to your application
	SDKMode_SDK_MODE_SYNC SDKMode = 1
	// Process() will handle the message asynchronously in a worker.
	// The SDKResponse will not contain any modified data. This mode should
	// only be used when you don't need to modify and pass it back to your
	// application, such as when discovering/monitoring PII only
	SDKMode_SDK_MODE_ASYNC SDKMode = 2
)

// Enum value maps for SDKMode.
var (
	SDKMode_name = map[int32]string{
		0: "SDK_MODE_UNSET",
		1: "SDK_MODE_SYNC",
		2: "SDK_MODE_ASYNC",
	}
	SDKMode_value = map[string]int32{
		"SDK_MODE_UNSET": 0,
		"SDK_MODE_SYNC":  1,
		"SDK_MODE_ASYNC": 2,
	}
)

func (x SDKMode) Enum() *SDKMode {
	p := new(SDKMode)
	*p = x
	return p
}

func (x SDKMode) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (SDKMode) Descriptor() protoreflect.EnumDescriptor {
	return file_sp_sdk_proto_enumTypes[1].Descriptor()
}

func (SDKMode) Type() protoreflect.EnumType {
	return &file_sp_sdk_proto_enumTypes[1]
}

func (x SDKMode) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use SDKMode.Descriptor instead.
func (SDKMode) EnumDescriptor() ([]byte, []int) {
	return file_sp_sdk_proto_rawDescGZIP(), []int{1}
}

// Common return response used by all SDKs
type SDKResponse struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// Contains (potentially) modified input data
	Data []byte `protobuf:"bytes,1,opt,name=data,proto3" json:"data,omitempty"`
	// Execution status of the last step
	Status ExecStatus `protobuf:"varint,2,opt,name=status,proto3,enum=protos.ExecStatus" json:"status,omitempty"`
	// Optional message accompanying the exec status for the last step
	StatusMessage *string `protobuf:"bytes,3,opt,name=status_message,json=statusMessage,proto3,oneof" json:"status_message,omitempty"`
	// An array of pipelines that the SDK executed and the status of each step
	PipelineStatus []*PipelineStatus `protobuf:"bytes,4,rep,name=pipeline_status,json=pipelineStatus,proto3" json:"pipeline_status,omitempty"`
	// Includes any metadata that the step(s) may want to pass back to the user.
	//
	// NOTE: Metadata is aggregated across all steps in the pipeline, so if two
	// steps both set a key "foo" to different values, the value of "foo" in the
	// response will be the value set by the last step in the pipeline.
	//
	// To learn more about "metadata", see SDK Spec V2 doc "Pipeline Step & Error
	// Behavior" section.
	Metadata map[string]string `protobuf:"bytes,5,rep,name=metadata,proto3" json:"metadata,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	// SDKMode is purely an informative field that tells the user the mode that the
	// SDK was running in when the response was generated.
	SdkMode SDKMode `protobuf:"varint,6,opt,name=sdk_mode,json=sdkMode,proto3,enum=protos.SDKMode" json:"sdk_mode,omitempty"`
}

func (x *SDKResponse) Reset() {
	*x = SDKResponse{}
	if protoimpl.UnsafeEnabled {
		mi := &file_sp_sdk_proto_msgTypes[0]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *SDKResponse) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*SDKResponse) ProtoMessage() {}

func (x *SDKResponse) ProtoReflect() protoreflect.Message {
	mi := &file_sp_sdk_proto_msgTypes[0]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use SDKResponse.ProtoReflect.Descriptor instead.
func (*SDKResponse) Descriptor() ([]byte, []int) {
	return file_sp_sdk_proto_rawDescGZIP(), []int{0}
}

func (x *SDKResponse) GetData() []byte {
	if x != nil {
		return x.Data
	}
	return nil
}

func (x *SDKResponse) GetStatus() ExecStatus {
	if x != nil {
		return x.Status
	}
	return ExecStatus_EXEC_STATUS_UNSET
}

func (x *SDKResponse) GetStatusMessage() string {
	if x != nil && x.StatusMessage != nil {
		return *x.StatusMessage
	}
	return ""
}

func (x *SDKResponse) GetPipelineStatus() []*PipelineStatus {
	if x != nil {
		return x.PipelineStatus
	}
	return nil
}

func (x *SDKResponse) GetMetadata() map[string]string {
	if x != nil {
		return x.Metadata
	}
	return nil
}

func (x *SDKResponse) GetSdkMode() SDKMode {
	if x != nil {
		return x.SdkMode
	}
	return SDKMode_SDK_MODE_UNSET
}

type PipelineStatus struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// ID of the pipeline
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// The name of the pipeline
	Name string `protobuf:"bytes,2,opt,name=name,proto3" json:"name,omitempty"`
	// The status of each step in the pipeline
	StepStatus []*StepStatus `protobuf:"bytes,3,rep,name=step_status,json=stepStatus,proto3" json:"step_status,omitempty"`
}

func (x *PipelineStatus) Reset() {
	*x = PipelineStatus{}
	if protoimpl.UnsafeEnabled {
		mi := &file_sp_sdk_proto_msgTypes[1]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *PipelineStatus) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*PipelineStatus) ProtoMessage() {}

func (x *PipelineStatus) ProtoReflect() protoreflect.Message {
	mi := &file_sp_sdk_proto_msgTypes[1]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use PipelineStatus.ProtoReflect.Descriptor instead.
func (*PipelineStatus) Descriptor() ([]byte, []int) {
	return file_sp_sdk_proto_rawDescGZIP(), []int{1}
}

func (x *PipelineStatus) GetId() string {
	if x != nil {
		return x.Id
	}
	return ""
}

func (x *PipelineStatus) GetName() string {
	if x != nil {
		return x.Name
	}
	return ""
}

func (x *PipelineStatus) GetStepStatus() []*StepStatus {
	if x != nil {
		return x.StepStatus
	}
	return nil
}

type StepStatus struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// The name of the step
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// Execution outcome status of the step
	Status ExecStatus `protobuf:"varint,2,opt,name=status,proto3,enum=protos.ExecStatus" json:"status,omitempty"`
	// Optional message accompanying the exec status
	StatusMessage *string `protobuf:"bytes,3,opt,name=status_message,json=statusMessage,proto3,oneof" json:"status_message,omitempty"`
	// Indicates if current or all future pipelines were aborted.
	//
	// IMPORTANT: The SDK running into an error does not automatically abort
	// current or all future pipelines - the user must define the abort conditions
	// for "on_error".
	AbortCondition AbortCondition `protobuf:"varint,4,opt,name=abort_condition,json=abortCondition,proto3,enum=protos.AbortCondition" json:"abort_condition,omitempty"`
}

func (x *StepStatus) Reset() {
	*x = StepStatus{}
	if protoimpl.UnsafeEnabled {
		mi := &file_sp_sdk_proto_msgTypes[2]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *StepStatus) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*StepStatus) ProtoMessage() {}

func (x *StepStatus) ProtoReflect() protoreflect.Message {
	mi := &file_sp_sdk_proto_msgTypes[2]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use StepStatus.ProtoReflect.Descriptor instead.
func (*StepStatus) Descriptor() ([]byte, []int) {
	return file_sp_sdk_proto_rawDescGZIP(), []int{2}
}

func (x *StepStatus) GetName() string {
	if x != nil {
		return x.Name
	}
	return ""
}

func (x *StepStatus) GetStatus() ExecStatus {
	if x != nil {
		return x.Status
	}
	return ExecStatus_EXEC_STATUS_UNSET
}

func (x *StepStatus) GetStatusMessage() string {
	if x != nil && x.StatusMessage != nil {
		return *x.StatusMessage
	}
	return ""
}

func (x *StepStatus) GetAbortCondition() AbortCondition {
	if x != nil {
		return x.AbortCondition
	}
	return AbortCondition_ABORT_CONDITION_UNSET
}

var File_sp_sdk_proto protoreflect.FileDescriptor

var file_sp_sdk_proto_rawDesc = []byte{
	0x0a, 0x0c, 0x73, 0x70, 0x5f, 0x73, 0x64, 0x6b, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x06,
	0x70, 0x72, 0x6f, 0x74, 0x6f, 0x73, 0x1a, 0x11, 0x73, 0x70, 0x5f, 0x70, 0x69, 0x70, 0x65, 0x6c,
	0x69, 0x6e, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x22, 0xf5, 0x02, 0x0a, 0x0b, 0x53, 0x44,
	0x4b, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x12, 0x12, 0x0a, 0x04, 0x64, 0x61, 0x74,
	0x61, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0c, 0x52, 0x04, 0x64, 0x61, 0x74, 0x61, 0x12, 0x2a, 0x0a,
	0x06, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x12, 0x2e,
	0x70, 0x72, 0x6f, 0x74, 0x6f, 0x73, 0x2e, 0x45, 0x78, 0x65, 0x63, 0x53, 0x74, 0x61, 0x74, 0x75,
	0x73, 0x52, 0x06, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x2a, 0x0a, 0x0e, 0x73, 0x74, 0x61,
	0x74, 0x75, 0x73, 0x5f, 0x6d, 0x65, 0x73, 0x73, 0x61, 0x67, 0x65, 0x18, 0x03, 0x20, 0x01, 0x28,
	0x09, 0x48, 0x00, 0x52, 0x0d, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x4d, 0x65, 0x73, 0x73, 0x61,
	0x67, 0x65, 0x88, 0x01, 0x01, 0x12, 0x3f, 0x0a, 0x0f, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e,
	0x65, 0x5f, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x18, 0x04, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x16,
	0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x73, 0x2e, 0x50, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65,
	0x53, 0x74, 0x61, 0x74, 0x75, 0x73, 0x52, 0x0e, 0x70, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65,
	0x53, 0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x3d, 0x0a, 0x08, 0x6d, 0x65, 0x74, 0x61, 0x64, 0x61,
	0x74, 0x61, 0x18, 0x05, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x21, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f,
	0x73, 0x2e, 0x53, 0x44, 0x4b, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x2e, 0x4d, 0x65,
	0x74, 0x61, 0x64, 0x61, 0x74, 0x61, 0x45, 0x6e, 0x74, 0x72, 0x79, 0x52, 0x08, 0x6d, 0x65, 0x74,
	0x61, 0x64, 0x61, 0x74, 0x61, 0x12, 0x2a, 0x0a, 0x08, 0x73, 0x64, 0x6b, 0x5f, 0x6d, 0x6f, 0x64,
	0x65, 0x18, 0x06, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x0f, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x73,
	0x2e, 0x53, 0x44, 0x4b, 0x4d, 0x6f, 0x64, 0x65, 0x52, 0x07, 0x73, 0x64, 0x6b, 0x4d, 0x6f, 0x64,
	0x65, 0x1a, 0x3b, 0x0a, 0x0d, 0x4d, 0x65, 0x74, 0x61, 0x64, 0x61, 0x74, 0x61, 0x45, 0x6e, 0x74,
	0x72, 0x79, 0x12, 0x10, 0x0a, 0x03, 0x6b, 0x65, 0x79, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52,
	0x03, 0x6b, 0x65, 0x79, 0x12, 0x14, 0x0a, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x18, 0x02, 0x20,
	0x01, 0x28, 0x09, 0x52, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x3a, 0x02, 0x38, 0x01, 0x42, 0x11,
	0x0a, 0x0f, 0x5f, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x5f, 0x6d, 0x65, 0x73, 0x73, 0x61, 0x67,
	0x65, 0x22, 0x69, 0x0a, 0x0e, 0x50, 0x69, 0x70, 0x65, 0x6c, 0x69, 0x6e, 0x65, 0x53, 0x74, 0x61,
	0x74, 0x75, 0x73, 0x12, 0x0e, 0x0a, 0x02, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52,
	0x02, 0x69, 0x64, 0x12, 0x12, 0x0a, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28,
	0x09, 0x52, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x12, 0x33, 0x0a, 0x0b, 0x73, 0x74, 0x65, 0x70, 0x5f,
	0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x18, 0x03, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x12, 0x2e, 0x70,
	0x72, 0x6f, 0x74, 0x6f, 0x73, 0x2e, 0x53, 0x74, 0x65, 0x70, 0x53, 0x74, 0x61, 0x74, 0x75, 0x73,
	0x52, 0x0a, 0x73, 0x74, 0x65, 0x70, 0x53, 0x74, 0x61, 0x74, 0x75, 0x73, 0x22, 0xcc, 0x01, 0x0a,
	0x0a, 0x53, 0x74, 0x65, 0x70, 0x53, 0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x12, 0x0a, 0x04, 0x6e,
	0x61, 0x6d, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x12,
	0x2a, 0x0a, 0x06, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0e, 0x32,
	0x12, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x73, 0x2e, 0x45, 0x78, 0x65, 0x63, 0x53, 0x74, 0x61,
	0x74, 0x75, 0x73, 0x52, 0x06, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x2a, 0x0a, 0x0e, 0x73,
	0x74, 0x61, 0x74, 0x75, 0x73, 0x5f, 0x6d, 0x65, 0x73, 0x73, 0x61, 0x67, 0x65, 0x18, 0x03, 0x20,
	0x01, 0x28, 0x09, 0x48, 0x00, 0x52, 0x0d, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x4d, 0x65, 0x73,
	0x73, 0x61, 0x67, 0x65, 0x88, 0x01, 0x01, 0x12, 0x3f, 0x0a, 0x0f, 0x61, 0x62, 0x6f, 0x72, 0x74,
	0x5f, 0x63, 0x6f, 0x6e, 0x64, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0e,
	0x32, 0x16, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x73, 0x2e, 0x41, 0x62, 0x6f, 0x72, 0x74, 0x43,
	0x6f, 0x6e, 0x64, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x0e, 0x61, 0x62, 0x6f, 0x72, 0x74, 0x43,
	0x6f, 0x6e, 0x64, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x42, 0x11, 0x0a, 0x0f, 0x5f, 0x73, 0x74, 0x61,
	0x74, 0x75, 0x73, 0x5f, 0x6d, 0x65, 0x73, 0x73, 0x61, 0x67, 0x65, 0x2a, 0x98, 0x01, 0x0a, 0x0a,
	0x45, 0x78, 0x65, 0x63, 0x53, 0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x15, 0x0a, 0x11, 0x45, 0x58,
	0x45, 0x43, 0x5f, 0x53, 0x54, 0x41, 0x54, 0x55, 0x53, 0x5f, 0x55, 0x4e, 0x53, 0x45, 0x54, 0x10,
	0x00, 0x12, 0x14, 0x0a, 0x10, 0x45, 0x58, 0x45, 0x43, 0x5f, 0x53, 0x54, 0x41, 0x54, 0x55, 0x53,
	0x5f, 0x54, 0x52, 0x55, 0x45, 0x10, 0x01, 0x12, 0x15, 0x0a, 0x11, 0x45, 0x58, 0x45, 0x43, 0x5f,
	0x53, 0x54, 0x41, 0x54, 0x55, 0x53, 0x5f, 0x46, 0x41, 0x4c, 0x53, 0x45, 0x10, 0x02, 0x12, 0x15,
	0x0a, 0x11, 0x45, 0x58, 0x45, 0x43, 0x5f, 0x53, 0x54, 0x41, 0x54, 0x55, 0x53, 0x5f, 0x45, 0x52,
	0x52, 0x4f, 0x52, 0x10, 0x03, 0x12, 0x15, 0x0a, 0x11, 0x45, 0x58, 0x45, 0x43, 0x5f, 0x53, 0x54,
	0x41, 0x54, 0x55, 0x53, 0x5f, 0x41, 0x53, 0x59, 0x4e, 0x43, 0x10, 0x04, 0x12, 0x18, 0x0a, 0x14,
	0x45, 0x58, 0x45, 0x43, 0x5f, 0x53, 0x54, 0x41, 0x54, 0x55, 0x53, 0x5f, 0x53, 0x41, 0x4d, 0x50,
	0x4c, 0x49, 0x4e, 0x47, 0x10, 0x05, 0x2a, 0x44, 0x0a, 0x07, 0x53, 0x44, 0x4b, 0x4d, 0x6f, 0x64,
	0x65, 0x12, 0x12, 0x0a, 0x0e, 0x53, 0x44, 0x4b, 0x5f, 0x4d, 0x4f, 0x44, 0x45, 0x5f, 0x55, 0x4e,
	0x53, 0x45, 0x54, 0x10, 0x00, 0x12, 0x11, 0x0a, 0x0d, 0x53, 0x44, 0x4b, 0x5f, 0x4d, 0x4f, 0x44,
	0x45, 0x5f, 0x53, 0x59, 0x4e, 0x43, 0x10, 0x01, 0x12, 0x12, 0x0a, 0x0e, 0x53, 0x44, 0x4b, 0x5f,
	0x4d, 0x4f, 0x44, 0x45, 0x5f, 0x41, 0x53, 0x59, 0x4e, 0x43, 0x10, 0x02, 0x42, 0x50, 0x5a, 0x3a,
	0x67, 0x69, 0x74, 0x68, 0x75, 0x62, 0x2e, 0x63, 0x6f, 0x6d, 0x2f, 0x73, 0x74, 0x72, 0x65, 0x61,
	0x6d, 0x64, 0x61, 0x6c, 0x2f, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x64, 0x61, 0x6c, 0x2f, 0x6c,
	0x69, 0x62, 0x73, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x73, 0x2f, 0x62, 0x75, 0x69, 0x6c, 0x64,
	0x2f, 0x67, 0x6f, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x73, 0xea, 0x02, 0x11, 0x53, 0x74, 0x72,
	0x65, 0x61, 0x6d, 0x64, 0x61, 0x6c, 0x3a, 0x3a, 0x50, 0x72, 0x6f, 0x74, 0x6f, 0x73, 0x62, 0x06,
	0x70, 0x72, 0x6f, 0x74, 0x6f, 0x33,
}

var (
	file_sp_sdk_proto_rawDescOnce sync.Once
	file_sp_sdk_proto_rawDescData = file_sp_sdk_proto_rawDesc
)

func file_sp_sdk_proto_rawDescGZIP() []byte {
	file_sp_sdk_proto_rawDescOnce.Do(func() {
		file_sp_sdk_proto_rawDescData = protoimpl.X.CompressGZIP(file_sp_sdk_proto_rawDescData)
	})
	return file_sp_sdk_proto_rawDescData
}

var file_sp_sdk_proto_enumTypes = make([]protoimpl.EnumInfo, 2)
var file_sp_sdk_proto_msgTypes = make([]protoimpl.MessageInfo, 4)
var file_sp_sdk_proto_goTypes = []interface{}{
	(ExecStatus)(0),        // 0: protos.ExecStatus
	(SDKMode)(0),           // 1: protos.SDKMode
	(*SDKResponse)(nil),    // 2: protos.SDKResponse
	(*PipelineStatus)(nil), // 3: protos.PipelineStatus
	(*StepStatus)(nil),     // 4: protos.StepStatus
	nil,                    // 5: protos.SDKResponse.MetadataEntry
	(AbortCondition)(0),    // 6: protos.AbortCondition
}
var file_sp_sdk_proto_depIdxs = []int32{
	0, // 0: protos.SDKResponse.status:type_name -> protos.ExecStatus
	3, // 1: protos.SDKResponse.pipeline_status:type_name -> protos.PipelineStatus
	5, // 2: protos.SDKResponse.metadata:type_name -> protos.SDKResponse.MetadataEntry
	1, // 3: protos.SDKResponse.sdk_mode:type_name -> protos.SDKMode
	4, // 4: protos.PipelineStatus.step_status:type_name -> protos.StepStatus
	0, // 5: protos.StepStatus.status:type_name -> protos.ExecStatus
	6, // 6: protos.StepStatus.abort_condition:type_name -> protos.AbortCondition
	7, // [7:7] is the sub-list for method output_type
	7, // [7:7] is the sub-list for method input_type
	7, // [7:7] is the sub-list for extension type_name
	7, // [7:7] is the sub-list for extension extendee
	0, // [0:7] is the sub-list for field type_name
}

func init() { file_sp_sdk_proto_init() }
func file_sp_sdk_proto_init() {
	if File_sp_sdk_proto != nil {
		return
	}
	file_sp_pipeline_proto_init()
	if !protoimpl.UnsafeEnabled {
		file_sp_sdk_proto_msgTypes[0].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*SDKResponse); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_sp_sdk_proto_msgTypes[1].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*PipelineStatus); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_sp_sdk_proto_msgTypes[2].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*StepStatus); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
	}
	file_sp_sdk_proto_msgTypes[0].OneofWrappers = []interface{}{}
	file_sp_sdk_proto_msgTypes[2].OneofWrappers = []interface{}{}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_sp_sdk_proto_rawDesc,
			NumEnums:      2,
			NumMessages:   4,
			NumExtensions: 0,
			NumServices:   0,
		},
		GoTypes:           file_sp_sdk_proto_goTypes,
		DependencyIndexes: file_sp_sdk_proto_depIdxs,
		EnumInfos:         file_sp_sdk_proto_enumTypes,
		MessageInfos:      file_sp_sdk_proto_msgTypes,
	}.Build()
	File_sp_sdk_proto = out.File
	file_sp_sdk_proto_rawDesc = nil
	file_sp_sdk_proto_goTypes = nil
	file_sp_sdk_proto_depIdxs = nil
}
